<?php

namespace QUI\ERP\Payments\Crypto\ETH;

use QUI;
use QUI\ERP\Accounting\Payments\Transactions\Transaction;
use QUI\ERP\Payments\Crypto\AbstractCryptoPayment;

/**
 * Class Payment
 *
 * Main payment class for ETH-based cryptocurrencies.
 */
class Payment extends AbstractCryptoPayment
{
    /**
     * @return string
     */
    public function getTitle(): string
    {
        return $this->getLocale()->get('quiqqer/payment-crypto-eth', 'payment.title');
    }

    /**
     * @return string
     */
    public function getDescription(): string
    {
        return $this->getLocale()->get('quiqqer/payment-crypto-eth', 'payment.description');
    }

    /**
     * Execute a refund
     *
     * @param QUI\ERP\Accounting\Payments\Transactions\Transaction $Transaction
     * @param float|int $amount
     * @param string $message
     * @param bool|string $hash - if a new hash will be used
     */
    public function refund(
        Transaction $Transaction,
        float|int $amount,
        string $message = '',
        bool|string $hash = false
    ): void {
        // @todo

//        try {
//            if ($hash === false) {
//                $hash = $Transaction->getHash();
//            }
//
//            $this->refundPayment($Transaction, $hash, $amount, $message);
//        } catch (PayPalException $Exception) {
//            QUI\System\Log::writeDebugException($Exception);
//
//            throw new QUI\ERP\Accounting\Payments\Transactions\RefundException([
//                'quiqqer/payment-crypto-eth',
//                'exception.Payment.refund_error'
//            ]);
//        } catch (\Exception $Exception) {
//            QUI\System\Log::writeException($Exception);
//
//            throw new QUI\ERP\Accounting\Payments\Transactions\RefundException([
//                'quiqqer/payment-crypto-eth',
//                'exception.Payment.refund_error'
//            ]);
//        }
    }
}
